// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancymysqlexception.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Base functionality for OpenSSL integration.
** 
*****************************************************************************/

#ifndef FANCYMYSQL_EXCEPTION_H
#define FANCYMYSQL_EXCEPTION_H

#include <fancyexception.h>

extern "C" {
  typedef struct st_mysql MYSQL;
}

namespace Fancy {
  namespace MySQL {

    class Exception : public Fancy::Exception
    {
    public:
      Exception (int facility,
                 int priority,
                 const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
;

      ~Exception() throw();

    protected:
      Exception (fancylog_service *service,
                 int facility,
                 int priority ) throw();
    };

    class MySQLException : public Exception
    {
    public:
      MySQLException (MYSQL *mysql,
                      int facility,
                      int priority,
                      const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,5,6)))
#endif
        ;

      ~MySQLException() throw();

      unsigned getErrno() const throw();
      bool isServerGone() const throw();
      const char *getStrError() const throw();
    
    private:
      unsigned err;
      char *str_err;
    };
  }
}

#endif
